/***************************************************************************
                          shrapnell.cpp  -  description
                             -------------------
    begin                : Mon Mar 6 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "shrapnell.h"
#include "defs.h"

Shrapnell::Shrapnell(SDL_Surface *dest, int px, int py, int sw, int sh, Vector sv, Vector av, float pc)
		  : screen(dest), x(px), y(py), old_x(px), old_y(py), w(sw), h(sh), dir(sv), dir_ch(av), pct_ch(pc)
{
	backgnd = new SDLSurface(w, h, SDL_SWSURFACE);
	shrapnell = new SDLSurface(w, h, SDL_SWSURFACE);
	
	//from screen
	SDL_Rect	sr = {x, y, w, h};
	SDL_Rect	dr = {0, 0, w, h};
	SDL_BlitSurface(screen, &sr, shrapnell->Surface(), &dr);
	
	cur_x = x;
	cur_y = y;
	next = prev = 0;
	pct = 100;
}

Shrapnell::Shrapnell()
{
	next = prev = 0;
	backgnd = shrapnell = 0;
}

Shrapnell::~Shrapnell()
{
	if (backgnd) delete backgnd;
	if (shrapnell) delete shrapnell;
}

void Shrapnell::GetBackgnd()
{
	if (x < 0) {
	    w += x;
	    x = 0;
	}
	if (y + h >= screen->h)
	    h = screen->h - y;
	if (x + w >= screen->w)
	    w = screen->w - x;
	//from screen
	SDL_Rect	sr = {x, y, w, h};
	SDL_Rect	dr = {0, 0, w, h};
	SDL_BlitSurface(screen, &sr, backgnd->Surface(), &dr);
}

void Shrapnell::Show(SDL_Rect *rects, int *rect_num)
{
	if (*rect_num < DRAWRECTS - 1) {
		SDL_Rect old_rect = {old_x, old_y, w, h};
		if (old_rect.x < 0) {
			old_rect.w += old_rect.x;
			old_rect.x = 0;
		}
		if (old_rect.y < 0) {
			old_rect.h += old_rect.y;
			old_rect.y = 0;
		}
		if (old_rect.x + old_rect.w >= screen->w)
			old_rect.w = screen->w - old_rect.x;
		if (old_rect.y + old_rect.h >= screen->h)
			old_rect.h = screen->h - old_rect.y;
		SDL_Rect rect = {x, y, w, h};
		if (rect.x < 0) {
			rect.w += rect.x;
			rect.x = 0;
		}
		if (rect.y < 0) {
			rect.h += rect.y;
			rect.y = 0;
		}
		if (rect.x + rect.w >= screen->w)
			rect.w = screen->w - rect.x;
		if (rect.y + rect.h >= screen->h)
			rect.h = screen->h - rect.y;
		rects[(*rect_num)++] = old_rect;
		rects[(*rect_num)++] = rect;
	}
	SC_Trp_X(screen->pixels, screen->w, x, y, shrapnell->Surface()->pixels, shrapnell->Width(), 0, 0, w, h, (int)pct);
	old_x = x;
	old_y = y;
}

void Shrapnell::Hide()
{
	backgnd->Blit(screen, old_x, old_y);
}

int Shrapnell::Update(int ms)
{
	//old
	old_x = x; old_y = y;
	//change direction
	dir.x += (float)ms * dir_ch.x;
	dir.y += (float)ms * dir_ch.y;
	//change pos
	cur_x += dir.x * (float)ms;
	cur_y += dir.y * (float)ms;
	x = (int)cur_x;
	y = (int)cur_y;
	//trancparency
	pct -= pct_ch * (float)ms;
	if ((int)pct <= 0) return 0;
	//check if still on screen
	return (!(x+w < 0 || y+h < 0 || y >= screen->h || x >= screen->w));
}

Shrapnell* Shrapnell::Next()
{
	return next;
}

Shrapnell* Shrapnell::Prev()
{
	return prev;
}
	
void Shrapnell::SetNext(Shrapnell *n)
{
	next = n;
}

void Shrapnell::SetPrev(Shrapnell *p)
{
	prev = p;
}
