/***************************************************************************
                          tetris.h  -  description
                             -------------------
    begin                : Tue Feb 29 2000
    copyright            : (C) 2000 by Michael Speck
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TETRIS_H
#define TETRIS_H

#include "bowl.h"
#include "number.h"
#include "defs.h"

/**
  *@author Michael Speck
  */

class Wave;
class Preview;

struct InitData {
	int level;
	int gametype;
	int next;
	char name[32];
	char name2[32];
	int anim_go;
	int anim_l;
	int transparency;
	int	hori_del;
	int snd_vol;
	int snd_on;
	Controls plyr1;
	Controls plyr2;
	int wholes;
	int send_all;
	int send_tetris;
	int bkgnd;
	int smooth_hori;
	int help;
	int bl_by_bl;
};

class Tetris {
public: 
	Tetris(SDL *sdl);
	~Tetris();
	InitData* Setup();
	HiScore* GetHiScore(int i);
	void InitGame(); //init new game
	int Run(); //main function
	void Refresh();
	void FullRefresh();
	int GameType();
	void PauseGame();
	void SnapShot();
	void InitInfoDisplay();
	void InitMultiInfo();
	void DrawFrame(int px, int py, int pw, int ph);
	void ReloadBkgnd();
private:
	SDL			*sdl;
	InitData	init_data;
	HiScore		*hiscore[3];
	HiScoreEntry player;
	HiScoreEntry player2;
	HiScoreEntry *winner;
	SDLSurface	*backgnd;
	SDLSurface  *picture;
	SDLSurface	*blocks;
	SDLSurface	*quest_mark;
	SDLFont		*font;
	char		keystate[SDLK_LAST]; //pressed or released?
	Number		*highscore;
	Number		*score;
	Number		*score2;
	Number		*lines;
	Number		*level;
	SDL_Rect	rects[DRAWRECTS];
	int			rect_num;
	Bowl		*bowl;
	Bowl		*bowl2;
	LevelInit	level_init[3][LEVELNUMBER];
	AdvLevelInit	adv_l_init[LEVELNUMBER]; //for gametype==B only
	ShrapnellList	*shrapnells;
	ShrapnellList	*shrapnells2;
	int			new_level;
	int			game_over;
	int			always_full_refresh;
	float		bonus_nonext;
	float		bonus_startlevel;
	int			wait_for_key;
	int			val_hiscore;
	int			snapshot;
	float		q_pct;
	float		q_pms;
	Preview     *preview;
	Preview     *preview2;
	int         total_lines;
	int         highest_level;
	char        *cfg_path;
};

#endif
